<template>
  <div>
    <v-row class="ma-0">
      <v-col cols="3" class="d-inline-block">
        <v-text-field
          label="Họ và Tên"
          outlined
          dense
          v-model="customerName"
          @keydown.enter="onSearch"
        ></v-text-field>
      </v-col>
      <v-col cols="3" class="d-inline-block">
        <v-text-field
          label="Email"
          outlined
          dense
          v-model="email"
          @keydown.enter="onSearch"
        ></v-text-field>
      </v-col>
      <v-col cols="3" class="d-inline-block">
        <v-select
          :items="statusItems"
          label="Trạng thái"
          dense
          outlined
          v-model="isActive"
        ></v-select>
      </v-col>
      <v-col cols="3" class="d-inline-block">
        <v-text-field
          label="Địa chỉ"
          outlined
          dense
          v-model="address"
          @keydown.enter="onSearch"
        ></v-text-field>
      </v-col>
    </v-row>
    <v-row class="ma-0">
      <v-col cols="12">
        <div class="d-inline-block">
          <v-btn color="primary" tile @click="onAdd">
            <v-icon>mdi-account-plus</v-icon>
            Thêm Mới
          </v-btn>
          <v-btn
            color="green white--text"
            tile
            @click="$refs.fileInput.click()"
          >
            <v-icon>mdi-transfer-down</v-icon>
            Import CSV
          </v-btn>
          <input
            type="file"
            ref="fileInput"
            class="d-none"
            accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
            @change="onFileSelected"
          />
          <v-btn color="green white--text" tile @click="onExportCSV">
            <v-icon>mdi-transfer-up</v-icon>
            Export CSV
          </v-btn>
        </div>
        <div class="d-inline-block float-right">
          <v-btn color="primary" tile @click="onSearch">
            <v-icon>mdi-magnify</v-icon>
            Tìm Kiếm
          </v-btn>
          <v-btn
            color="green lighten-2 white--text"
            tile
            @click="onClearSearch"
          >
            <v-icon>mdi-close</v-icon>
            Xóa Tìm
          </v-btn>
        </div>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import customerService from "../../../services/customerService";

export default {
  props: {
    params: {
      type: Object,
      required: true,
      default: {},
    },
  },
  data() {
    return {
      statusItems: [
        {
          text: "Không hoạt động",
          value: 0,
        },
        {
          text: "Hoạt động",
          value: 1,
        },
      ],
    };
  },
  computed: {
    customerName: {
      get() {
        return this.params.customerName;
      },
      set(value) {
        this.$emit("onChangeParams", {
          key: "customerName",
          value,
        });
      },
    },
    email: {
      get() {
        return this.params.email;
      },
      set(value) {
        this.$emit("onChangeParams", {
          key: "email",
          value,
        });
      },
    },
    address: {
      get() {
        return this.params.address;
      },
      set(value) {
        this.$emit("onChangeParams", {
          key: "address",
          value,
        });
      },
    },
    isActive: {
      get() {
        return this.params.isActive;
      },
      set(value) {
        this.$emit("onChangeParams", {
          key: "isActive",
          value,
        });
      },
    },
  },
  methods: {
    onSearch() {
      this.$emit("onSearch");
    },
    onClearSearch() {
      this.$emit("onClearSearch");
    },
    onAdd() {
      this.$emit("onAdd");
    },
    onFileSelected(e) {
      const files = e.target.files || e.dataTransfer.files;
      if (!files.length) return;
      const file = files[0];

      this.$store.commit("loading", true);
      const formData = new FormData();
      formData.append("file", file);
      customerService
        .importCSV(formData)
        .then((response) => {
          this.onClearSearch();
          this.$refs.fileInput.value = null;
          this.$store.commit("loading", false);
          this.$store.commit("showMessageSuccess", "Đã import thành công.");
        })
        .catch((error) => {
          console.log(error.response)
          console.log(error.response.data)
          console.log(error.response.data.errors)
          this.$refs.fileInput.value = null;
          let msgError = "";
          if (error.response.status === 422) {
            const dataErrors = error.response.data.errors;
            let errors = [];
            for (const [key, value] of Object.entries(dataErrors)) {
              console.log(`Loi ${key}:: `, value)
              let msgRow = `Lỗi dòng số ${value.row}. Nội dung lỗi: ${value.errors.toString()}`
              errors.push(msgRow);
            }
            msgError = errors.toString();
          } else {
            msgError = error.response.data.message;
          }
          this.$store.commit("loading", false);
          this.$store.commit("showMessageError", msgError);
        });
    },
    onExportCSV() {
      this.$store.commit("loading", true);
      customerService
        .exportCSV(this.params)
        .then((response) => {
          let element = document.createElement("a");
          element.setAttribute("href", response.data);
          element.setAttribute("download", `customers.xlsx`);
          document.body.appendChild(element);
          element.click();
          document.body.removeChild(element);

          this.$store.commit("loading", false);
          this.$store.commit("showMessageSuccess", "Đã export thành công.");
        })
        .catch((error) => {
          this.$store.commit("loading", false);
          this.$store.commit("showMessageError", "Không thể export excel.");
        });
    },
  },
};
</script>
<style scoped></style>
